/* KALKULACKA PRE CELE CISLA - vstup pre YACC */

%start kalkul
%token CISLO PAMAT
%token PLUS MINUS KRAT DELENE
%token PRIRAD CR LZAT PZAT INY
/* priorita a asociativita operatorov */
%left PLUS MINUS
%left KRAT DELENE
%left UMINUS /* pre unarne minus */


%{
#include "lex.yy.c" /* vlozenie lex. analyzatora */
int mem = 0;        /* pamat */

void yyerror(char *);
int yyparse(void), main(void);
%}

%%
kalkul :
      | kalkul vypocet
      | kalkul pamatanie
      ;
pamatanie : PAMAT PRIRAD vyraz CR   { mem = $3; }
      ;
vypocet : vyraz CR                  { printf("%d\n", $1);}
      ;
vyraz : vyraz PLUS vyraz            { $$= $1 + $3;}
      | vyraz MINUS vyraz           { $$= $1 - $3;}
      | vyraz KRAT vyraz            { $$= $1 * $3;}
      | vyraz DELENE vyraz          { $$= $1 / $3;}
      | MINUS vyraz  %prec UMINUS   { $$= - $2;}
      | LZAT vyraz PZAT             { $$= $2; }
      | PAMAT                       { $$= mem; }
      | CISLO                       { $$= $1; }
      ;
%%

void yyerror(char *s)
{
    printf("%s\n",s);
}

int main()
{
    printf("KALKULACKA ZAPNUTA\n");
    (void) yyparse();
    printf("KALKULACKA VYPNUTA\n");
    return 0;
}

